package game;

import graphics.GFX;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;

import com.jogamp.opengl.GL2;

import calc.V3D;
import mechanics.Entity;

public class Credits extends Entity
{
	public static final int SEP = 20;
	public static final float X = 148;
	static int logoLine1,logoLine2;
	String[] credits;

	int fade;
	float alpha;

	public Credits()
	{
		super(new V3D(320,240,0));
		setDepth(Integer.MIN_VALUE+6);
		ArrayList<String> strs = new ArrayList<String>();
		alpha = 0;
		fade = 1;
		int i=0;
		try
		{
			BufferedReader bi = new BufferedReader(new FileReader("credits.dat"));
			String s;
			while((s=bi.readLine())!=null)
			{
				if(s.equals("$1"))
				{
					logoLine1 = i;
					s="";
				}
				else if(s.equals("$2"))
				{
					logoLine2 = i;
					s="";
				}
				strs.add(s);
				i++;
			}
			bi.close();
		}
		catch (IOException e)
		{e.printStackTrace();}

		credits = new String[strs.size()];
		strs.toArray(credits);
		alarm[0] = 30*60;
		speed.p[1] = -(double)(credits.length*SEP+240)/alarm[0];
	}
	@Override
	public void step()
	{
		super.step();
		if(fade==1 && alpha<1)
			alpha+=1f/30;
		else if(fade==-1)
		{
			alpha-=1f/30;
			if(alpha<0)
				destroy();
		}
		else
			alpha=1;
	}

	@Override
	public void alarm(int i)
	{
		if(i==0)
			fade = -1;
	}

	@Override
	public void destroy()
	{
		super.destroy();
	}
	@Override
	public void render()
	{
		GL2 gl = GFX.gl;
		gl.glColor4f(0,0,0,0.25f*alpha);
		GFX.drawRectangle(X,0,320,240);
		gl.glColor3f(1,1,1);
		GFX.drawTexture(GFX.tex("LogoPatapon"), 0, X+12, 
				(float) (pos.y()+SEP*logoLine1), 0, GFX.NORTHWEST, 1, 1, 0);
		GFX.drawTexture(GFX.tex("LogoPony"), 0, X+12, 
				(float) (pos.y()+SEP*logoLine2), 0, GFX.NORTHWEST, 1, 1, 0);

		Overlay.textBegin(Overlay.courierNew12);
		for(int i=0; i<credits.length; i++)
		{
			Overlay.textDraw(Overlay.courierNew12,(int)(X+5),(int)(pos.y()+i*SEP),credits[i]);
		}
		Overlay.textEnd(Overlay.courierNew12);
	}
}
