package game;

import audio.Audio;
import graphics.GFX;
import calc.V3D;
import mechanics.Entity;

public class FlowerPot extends Entity
	{

	public FlowerPot(int x)
		{
		super(new V3D(x,PataController.GND_Y-480,0));
		tex = GFX.tex("flower");
		Audio.get("fall").setGain(0.7);
		Audio.get("fall").play();
		orientation = GFX.CENTER;
		}
	@Override
	public void step()
		{
		speed.add(0,0.4,0);
		super.step();
		Pinkie c = null;
		for(Pinkie p:Pinkie.pinkies)
			{
			if(p!=Pinkie.flagHolder && pos.distance(p.pos)<Pinkie.RADIUS+16)
				c = p;
			}
		if(c!=null)
			{
			new Explosion(pos.clone());
			destroy();
			if(c.anim!=Pinkie.DEFEND)
				c.hit(3);
			}
		else if(pos.y()>PataController.GND_Y)
			{
			new Explosion(pos.clone());
			destroy();
			}
		}
	}
