package game;

import audio.Audio;
import calc.V3D;
import mechanics.Entity;

public class Intro extends Entity implements AnimationListener
	{
	static boolean introductionRunning;
	static int yMinus = 0;

	public static boolean aPressed=false,sPressed=false,dPressed=false;

	PonyAnimator pony;
	static Intro me;
	int schedule;
	
	/**Setting this to true skips the first part of the intro*/
	boolean startAtRhythms = false;
	
	public Intro(V3D pos)
		{
		super(pos);	
		PataController.marchEnabled = false;
		PataController.attackEnabled = false;
		PataController.defendEnabled = false;
		aPressed = false;
		sPressed = false;
		dPressed = false;
		me = this;
		introductionRunning = true;
		if(startAtRhythms)
			{
			schedule = 14;
			alarm[1]=30;
			PataController.me.control = false;
			PataController.me.validateUserInput = 0;
			View.y=0;
			yMinus=0;
			visible = false;
			Overlay.talk(null);
			}
		else
			{
			schedule = 0;
			PataController.me.control = false;
			PataController.me.validateUserInput = 0;
			View.y=-240;
			yMinus=240;
			pony = new PonyAnimator(new V3D(160,-32,0),false);
			pony.animate(PonyAnimator.CLIMBUP);
			pony.setAnimationListener(this);
			visible = false;
			Overlay.talkString = "";
			Overlay.targetString = null;
			Overlay.stringPos=0;
			}
		}
	@Override
	public void step()
		{
		super.step();
		if(schedule == 13)//Scroll down
			{
			yMinus-=2;
			if(yMinus<=0)
				{
				yMinus = 0;
				schedule = 14;
				alarm[1]=30;
				}
			}
		
		if(schedule == 9 && aPressed && sPressed && dPressed)
			schedule = 10;
			
		}

	@Override
	public void destroy()
		{
		super.destroy();
		me = null;
		Intro.introductionRunning = false;
		if(pony!=null)
			pony.destroy();
		}
	@Override
	public void alarm(int index)
		{
		if(index==0)
			Audio.get("Cheer").play();
		else if(index==1)
			{
			Pinkie.flagHolder.eyeImg=3;
			talk("Repeat after me; Pata Pata Pata Pon!");
			schedule = 15;
			}
		else if(index==2)
			{
			Pinkie.flagHolder.eyeImg=0;
			talk("You better remember it!");
			alarm[3] = 120;
			}
		else if(index==3)
			{
			talk("This is the Aria of Attack!");
			spawnSymbols(1);
			schedule = 19;
			}
		else if(index==4)
			{
			talk("This is the Lament of Defense!");
			spawnSymbols(2);
			schedule = 22;
			}
		else if(index==5)
			{
			talk("That's it!! Let's go!");
			PataController.attackEnabled = true;
			PataController.marchEnabled = true;
			PataController.defendEnabled = true;
			PataController.me.validateUserInput = 1;
			PataController.me.control = true;
			alarm[6] = 120;
			}
		else if(index==6)
			{
			Overlay.talkString = null;
			destroy();
			}
			 
		}
	@Override
	public void ponyAnimatorAnimationComplete(int animationIndex)
		{
		if(Overlay.targetString==null)
			{
			if(schedule==0)
				{
				schedule = 1;
				pony.animate(PonyAnimator.LOOKBACK);
				talk("We did it, girls!");
				alarm[0]=17;
				}
			else if(schedule==2)
				{
				schedule = 3;
				pony.animate(PonyAnimator.IDLE);
				talk("Please guide us with your drums!");
				}
			else if(schedule==5)
				{
				schedule = 6;
				pony.animate(PonyAnimator.POINTLEFT);
				//talk("Press A for the PON");
				}
			else if(schedule==6)
				{
				schedule = 7;
				pony.animate(PonyAnimator.POINTUP);
				//talk("Press S for the PATA");
				}
			else if(schedule==7)
				{
				schedule = 8;
				pony.animate(PonyAnimator.POINTRIGHT);
				//talk("Press D for the CHAKA");
				}
			else if(schedule==8)
				{
				schedule = 9;
				pony.animate(PonyAnimator.IDLE);
				talk("Try it! Press the A, S and D keys!");
				PataController.me.control = true;
				}
			else if(schedule==10)
				{
				schedule = 11;
				pony.animate(PonyAnimator.IDLE);
				talk("Yay! Now it's time for some rhythms!");
				PataController.me.control = false;
				}
			else if(schedule==11)
				{
				schedule = 12;
				pony.animate(PonyAnimator.CLIMBDOWN);
				}
			else if(schedule==12)
				{
				schedule = 13;
				pony.destroy();
				pony = null;
				Overlay.talkString = null;
				}
			else //Auto
				{
				if(schedule!=9)
					schedule++;
				pony.animate(PonyAnimator.IDLE);
				}
			}
		else
			{
			pony.animate(PonyAnimator.IDLE);
			}
		}
	private void talk(String string)
		{
		Overlay.talk(string);
		if(pony!=null)
			pony.talking = true;
		}
	public static void beat(int index, int numValidMeasures)
		{
		if(me!=null)
			me.beatInst(index, numValidMeasures);
		}
	private void beatInst(int index, int numValidMeasures)
		{
		if(schedule==15 && Overlay.targetString==null && index%4==0)
			{schedule = 16;}
		if(schedule==16)
			{
			String drum = "WheeHit";
			if(index%4==3)
				drum = "GoHit";
			Audio.get(drum).play();
			if(index%4==3)
				{
				schedule = 17;
				PataController.marchEnabled = true;
				PataController.me.validateUserInput = 2;
				PataController.me.control = true;
				}
				
			}
		if(schedule==19 && index%4==0)
			{schedule = 20;}
		if(schedule==20)
			{
			String drum = "GoHit";
			if(index%4==2)
				drum = "WheeHit";
			Audio.get(drum).play();
			if(index%4==3)
				{
				schedule = 21;
				alarm[4] = 90;
				}
				
			}
		
		if(schedule==22 && index%4==0)
			{schedule = 23;}
		if(schedule==23)
			{
			String drum = "HeyHit";
			if(index%4==2)
				drum = "WheeHit";
			if(index%4==3)
				drum = "GoHit";
			Audio.get(drum).play();
			if(index%4==3)
				{
				schedule = 24;
				alarm[5] = 90;
				}
			}
		}
	public static void failInput(int type)
		{
		if(me!=null && me.schedule == 17)
			{
			String fail = null;
			if (type==1)
				fail = "That's not on the beat at all!";
			else if (type==2)
				fail = "Don't hit the drum while I'm responding!";
			else if (type==3)
				fail = "Woah, that's too funky!";
			else if (type==0)
				fail = "You skipped a beat!";
			else if (type==4 && Overlay.targetString==null &&
				(Overlay.talkString!=null && 
					!Overlay.talkString.startsWith("We'll take") && !Overlay.talkString.startsWith("It's you,")))
				{
				if(Math.random()<0.5)
					fail = "We'll take turns! Pata Pata Pata Pon!";
				else
					fail = "It's you, then me, then you again!";
				}
			else if (type==5)
				fail = "Good, but you're playing the wrong song!";
			else if (type==6)
				fail = "You must start on the first beat!";
			if(fail!=null)
				{
				me.talk(fail);
				}
			}
		}
	public static void spawnSymbols(int j)
		{
		for(int i=0; i<6; i++)
			{
			String stamp = "pata";
			if((j==0 && i==3) || (j==1 && i!=2) || (j==2 && i==3))
				stamp = "pon";
			if(j==2 && i<=1)
				stamp = "chaka";
			if(i==4) stamp = "equals";
			if(i==5)
				{if(j==0)stamp = "march";
				else if(j==1)stamp = "attack";
				else stamp = "defend";}
			Stamp s = new Stamp(new V3D(16+24*i,16+32*j,0),stamp);
			s.xScale = 0.5f;
			s.yScale = 0.5f;
			s.fade = false;
			s.followScreen = true;
			}
		}

	public static void successfulInput()
		{
		if(me!=null)
			{
			if(PataController.me.numValidMeasures>=7)
				{
				me.talk("Good job! That's the March of Mobility!");
				spawnSymbols(0);
				me.schedule = 18;
				me.alarm[2] = 160;
				PataController.me.control=false;
				PataController.me.validateUserInput=0;
				PataController.me.numValidMeasures = 0;
				PataController.me.userInputValid = false;
				PataController.me.failing = true;
				}
			else if(PataController.me.numValidMeasures==0)
				{
				if(Math.random()<0.5)
					me.talk("That's it! Keep it going after me!");
				else
					me.talk("That's it! Go for a 5X combo!");
				}
			else 
				{
				if(Math.random()<0.5)
					me.talk("Pata Pata Pata Pon!");
				else
					me.talk("Now you're getting it right!");
				}
			}
		}
	}
