package game;

import calc.Calc;
import calc.V3D;
import mechanics.Entity;

public class LevelController3 extends Entity implements AnimationListener
	{
	int nextEventBeat;
	final double STD = 1d/3;
	
	boolean existed;
	boolean started;
	int flippet = 0;
	
	PonyAnimator pony;
	static LevelController3 me;
	
	public LevelController3(V3D pos)
		{
		super(pos);
		me = this;
		started = false;
		existed = false;
		PataController.drums[1] = "AbbrHit";
		PataController.setMusicName("Tar");
		PataController.me.validateUserInput = 3;
		PataController.goalX = Integer.MAX_VALUE;
		visible = false;
		Scenery.spawnGrass();
		pony = new PonyAnimator(new V3D(-128,0,0),true);
		pony.scale = 48;
		pony.pos.p[1]=240-1.509*pony.scale;
		pony.animate(PonyAnimator.STANDTROT);
		pony.animate = false;
		pony.setAnimationListener(this);
		Calc.matrixMultiply3OptFirst(pony.master.postMatrix, Calc.makeZMatrix((float) (Math.PI/2)));
		
		nextEventBeat = -1;
		
		}
	@Override
	public void destroy()
		{
		super.destroy();
		me = null;
		}
	@Override
	public void step()
		{
		if(Pinkie.flagHolder.mode==Pinkie.MARCH && !started)
			{
			pony.animate(PonyAnimator.STANDTROT);
			pony.animate = true;
			pony.speed.p[0] = STD;
			started = true;
			new Credits();
			}
		
		super.step();
		}
	@Override
	public void alarm(int index)
		{
		if (index==0)
			{
			pony.animate(PonyAnimator.TURN);
			pony.animate = true;
			}
		else if(index==1)
			{
			Calc.matrixMultiply3OptFirst(pony.master.postMatrix, Calc.makeZMatrix((float) (Math.PI)));
			pony.flipVision = false;
			pony.animate(PonyAnimator.RUN);
			pony.speed.p[0] = 9;
			pony.animate = true;
			}
		else if (index==2)
			{
			pony.animate(PonyAnimator.COUNT);
			pony.animate = true;
			}
		else if (index==3)//Portal spotted
			{
			new ThrownFlag();
			for(Pinkie p: Pinkie.pinkies)
				{
				p.targetX = p.pos.x()+Math.random()*48;
				p.alarm[10] = 90+(int)(Math.random()*30);
				}
			me.alarm[4] = 240;
			}
		else if (index==4)
			{
			Portal.me.destroy();
			for(Pinkie p: Pinkie.pinkies)
				p.destroy();
			me.alarm[5] = 160;
			}
		else if (index==5)//End
			{
			PataController.me.endLevel(PataController.END_FINAL);
			}
		else if(index==10)
			{
			new Portal(new V3D(Pinkie.flagHolder.pos.x()+480,PataController.GND_Y,10));
			PataController.me.control = false;
			PataController.me.validateUserInput = 0;  
			PataController.goalX = (int) Portal.me.pos.x();
			}
		}
	@Override
	public void ponyAnimatorAnimationComplete(int animationIndex)
		{
		if(animationIndex==PonyAnimator.COUNT)
			{
			pony.animate(PonyAnimator.STANDTROT);
			pony.speed.p[0] = STD;
			}
		else if(animationIndex==PonyAnimator.RUNTROT)
			{
			pony.speed.p[0]=STD;
			pony.animate(PonyAnimator.TROT);
			}
		else if(animationIndex==PonyAnimator.RUN)
			{
			if(pony.pos.x()<640)
				pony.animate(animationIndex);
			else
				pony.animate(PonyAnimator.RUNTROT);
			}
		else if(pony.flipVision && animationIndex == PonyAnimator.TROT && pony.pos.x()<-128)
			{
			pony.animate = false;
			pony.speed.set(0,0,0);
			alarm[1]=50;
			}
		else if(animationIndex == PonyAnimator.TURN)
			{
			Calc.matrixMultiply3OptFirst(pony.master.postMatrix, Calc.makeZMatrix((float) (Math.PI)));
			pony.animate(PonyAnimator.TROT);
			pony.speed.p[0] = -5;
			}
		else if(pony.pos.x()>136 && flippet == 0)
			{
			pony.animate(PonyAnimator.STANDTROT);
			pony.animate = false;
			pony.interp = 0;
			alarm[2] = 30;
			pony.speed.p[0] = -1;
			flippet = 1;
			}
		else if(pony.pos.x()>192 && flippet == 1)
			{
			pony.animate(PonyAnimator.STANDTROT);
			pony.animate = false;
			pony.interp = 0;
			alarm[0] = 30;
			pony.speed.p[0] = -1;
			flippet = 2;
			}
		else
			pony.animate(PonyAnimator.TROT);
		}
	public static void portal()
		{
		me.alarm[10] = 1;
		me.alarm[3] = 90;
		PataController.me.control = false;
		PataController.me.validateUserInput = 0;  
		}
	}
