package game;

import com.jogamp.opengl.GL2;

import graphics.GFX;
import graphics.Tex;
import calc.Calc;
import calc.V3D;
import mechanics.Entity;
import mechanics.Scene;

public class Parasprite extends Entity
	{
	
	static Tex eyeTex = GFX.tex("ParaspriteEyes");
	static Tex wingTex = GFX.tex("ParaspriteWings");
	static
		{
		wingTex.origin.setLocation(16,24);
		}
	float[] wingColor = new float[4];
	float[] eyeColor = new float[4];

	int fourstage;
	int blinkTimer;
	/**Location in cloud*/
	double dir,sp;
	
	public double targetX,targetY;
	
	public Parasprite(V3D pos, double dir, double sp)
		{
		super(pos);
		targetX = pos.x();
		targetY = pos.y();
		setDepth(1);
		fourstage=(int)(4*Math.random());
		this.dir=dir;
		this.sp=sp;
		tex = GFX.tex("ParaspriteBody");
		orientation = GFX.CENTER;
		Calc.fill(color, 0.4f*(float)Math.random(), 0.4f*(float)Math.random(), 0.4f*(float)Math.random(), 1);
		Calc.fill(wingColor, 0.4f+0.6f*(float)Math.random(), 0.4f+0.6f*(float)Math.random(), 0.4f+0.6f*(float)Math.random(), 1);
		Calc.fill(eyeColor, 0.6f+0.4f*(float)Math.random(), 0.6f+0.4f*(float)Math.random(), 0.6f+0.4f*(float)Math.random(), 1);
		}
	@Override
	public void step()
		{
		blinkTimer-=1;
		if(blinkTimer<=0)
			blinkTimer=30+(int)(Math.random()*90);
		fourstage++;if(fourstage>=4)fourstage=0;
		
		//pos.set(targetX,targetY,0);
		speed.add((Calc.signSquare(targetX-pos.x())-speed.x()*96)/5120,(Calc.signSquare(targetY-pos.y())-speed.y()*96)/5120,0);
		speed.accelerate(-speed.sqLen()/128);
		if(speed.x()>0)
			xScale=1;
		else
			xScale=-1;
		if(pos.y()>PataController.GND_Y && speed.y()>0)
			speed.y(speed.y()*-0.66);
		
		super.step();
		}
	
	@Override
	public void render()
		{
		GL2 gl = GFX.gl;
		if(Scene.blink<1)
			{
			gl.glColor4fv(wingColor,0);
			GFX.drawTexture(wingTex, (int)fourstage/2, (float)pos.x(), (float)pos.y(), (float)pos.z(), GFX.NORTHWEST, xScale, 1, 0);
			}
		gl.glColor4fv(color,0);
		GFX.drawTexture(tex, 0, (float)pos.x(), (float)pos.y(), (float)pos.z(), orientation, xScale, 1, 0);
		gl.glColor4fv(eyeColor,0);
		GFX.drawTexture(eyeTex, (blinkTimer<3?1:0), (float)pos.x(), (float)pos.y(), (float)pos.z(), orientation, xScale, 1, 0);
		}

	}
