package game;

import java.util.ArrayList;

import com.jogamp.opengl.GL;
import com.jogamp.opengl.GL2;

import audio.Audio;
import audio.StupidClip;

import graphics.GFX;
import graphics.Tex;
import calc.Calc;
import calc.V3D;
import main.Main;
import mechanics.Entity;
import mechanics.Scene;

public class Pinkie extends Entity implements TailParent
	{
	static final int STAND = 0;
	static final int WALK = 1;
	static final int JUMP = 2;
	static final int RUN = 3;
	static final int DUCK = 4;
	static final int DEAD = 5;
	
	static final int IDLE = 0;
	static final int MARCH = 1;
	static final int FLINCH = 2;
	static final int ATTACK = 3;
	static final int DEFEND = 4;
	
	static ArrayList<Pinkie> pinkies = new ArrayList<Pinkie>();
	
	//float[] eyeColor = new float[4];
	float[] hairColor = new float[4];	
	
	static final double RADIUS = 19-3+13;
	private static final int MAX_LIFE = 6;
	
	double headImg = 0;
	double eyeImg = 0;
	double bodyImg = 0;
	double headRot = 0;
	
	
	
	int anim = STAND;
	int mode = IDLE;
	/**The flag holder pinkie(does not attack)*/
	static Pinkie flagHolder;
	static int flagType = IDLE;
	
	double bwalk=0.18;
	double fwalk=0.32;
	int walkTime=20;
	double runPhase=0;
	int runTime=15;
	
	int blinkTimer=30+(int)(90*Math.random());
	
	double yPlus=0;
	
	static Tex sB1 = GFX.tex("PonyThigh");
	static Tex sB3 = GFX.tex("PonyRearHoof");
	
	static Tex sF1 = GFX.tex("PonyElbow");
	static Tex sF3 = GFX.tex("PonyFrontHoof");
	static{
		GFX.tex("Flag").origin.setLocation(2, 0);
	
		sB1.origin.setLocation(4, 5);
		sB1.setRepeating(Tex.NO_REPEAT);
		sB3.origin.setLocation(9+4, 3);
		sB3.setRepeating(Tex.NO_REPEAT);
		sF1.origin.setLocation(4, 3);
		sF1.setRepeating(Tex.NO_REPEAT);
		sF3.origin.setLocation(2+5, 3);
		sF3.setRepeating(Tex.NO_REPEAT);
		}
	
	final double walkAmplitude = 32;
	final double walkSpeed = walkAmplitude/walkTime*1.2;
	final double runSpeed = walkSpeed*3.2;
	
	/**approx 0-30, reset each second beat*/
	int beatTimer;
	
	double BRx=3+0.07*walkAmplitude+1;
	double BRy=0;
	double BRi=0;
	double BLx=3-0.07*walkAmplitude;
	double BLy=0;
	double BLi=0;

	double FRx=0.07*walkAmplitude+1;
	double FRy=0;
	double FRi=0;
	double FLx=-0.07*walkAmplitude;
	double FLy=0;
	double FLi=0;
	
	Tail firstTail;
	
	double targetX;
	double yStart;
	/*Whether to hang head when standing or walking.*/
	private boolean headDown;
	private boolean twitching;
	
	/**Current health*/
	private int life;
	/**0-1, counts down after damage*/
	private double damageTimer;
	public boolean thrownFlag;
	
	public Pinkie(V3D pos, boolean holdsFlag)
		{
		super(pos);
		life = MAX_LIFE;
		yStart = pos.y();
		thrownFlag = false;
		twitching = false;
		headDown=false;
		pinkies.add(this);
		targetX = pos.x();
		if(holdsFlag)
			{flagHolder = this;
			flagType = IDLE;
			setDepth(-1);}
		else if(Math.random()<0.5)
			setDepth(1);
		else
			setDepth(0);
		//Calc.fill(eyeColor, 0f, 0.25f, 1f, 1f);
		Calc.fill(color, 1f, 0.6f, 0.85f, 1f);
		Calc.fill(hairColor, 1f, 0.45f, 0.75f, 1f);
		int xx=11, yy=24;
		GFX.tex("PonyHead").origin.setLocation(xx, yy);
		GFX.tex("PonyHead").setRepeating(Tex.NO_REPEAT);
		xx=3; yy=11;
		GFX.tex("PonyEye").origin.setLocation(xx, yy);
		GFX.tex("PonyEye").setRepeating(Tex.NO_REPEAT);
		xx=19; yy=24;
		GFX.tex("PonyHair").origin.setLocation(xx, yy);
		GFX.tex("PonyHair").setRepeating(Tex.NO_REPEAT);
		
		GFX.tex("PonyBody").setRepeating(Tex.NO_REPEAT);
		
		tailRegen();
		}
	@Override
	public void destroy()
		{
		super.destroy();
		}
	
	@Override
	public void step()
		{
		beatTimer++;
		/*if(IOH.checkKey(KeyEvent.VK_L) && flagHolder!=this)
			die();*/
		
		if(damageTimer>0)
			damageTimer-=1d/90;
		
		if(anim==DEAD)
			{
			speed.p[1]+=0.25;
			if(pos.y()>PataController.GND_Y+32)
				{
				new Explosion(pos.clone().y(PataController.GND_Y));
				destroy();
				}
			}
		else
			{
			if(anim==JUMP)
				{
				speed.p[1]+=0.25;
				if(pos.y()>=yStart)
					{
					speed.set(0,0,0);
					pos.y(yStart);
					anim = STAND;
					headImg=0;
					eyeImg=0;
					}
				}
			if(anim!=JUMP)
				{
				if(Math.abs(targetX-pos.x())>runSpeed)
					{
					if(mode==MARCH/* || targetX<pos.x()*/)
						{
						if(anim!=WALK)
							{bwalk=0.18;
							fwalk=0.32;
							
							BRx=3+0.07*walkAmplitude+1;
							BRy=0;
							BRi=0;
							BLx=3-0.07*walkAmplitude;
							BLy=0;
							BLi=0;
							
							FRx=0.07*walkAmplitude+1;
							FRy=0;
							FRi=0;
							FLx=-0.07*walkAmplitude;
							FLy=0;
							FLi=0;}
						anim = WALK;
						}
					else
						anim=RUN;
					
					if(pos.x()>targetX)	
						{
						setXScale(-1);
						pos.p[0]-=anim==RUN?runSpeed:walkSpeed;
						}
					else
						{
						setXScale(1);
						pos.p[0]+=anim==RUN?runSpeed:walkSpeed;
						}
					}
				else
					{
					if(mode==ATTACK)//Nothing there
						{
						eyeImg = 0;
						headImg = 0;
						targetX = flagHolder.targetX-128+Math.random()*200;
						mode = IDLE;
						}
					if(anim==RUN)
						{
						eyeImg = 0;
						headImg=0;
						}
					
					if(mode==DEFEND)
						anim = DUCK;
					else
						anim = STAND;
					setXScale(1);
					}
				}
			
			
			blinkTimer-=1;
			if(eyeImg<2)
				eyeImg = (blinkTimer<3?1:0);
			if(blinkTimer<=0)
				blinkTimer=30+(int)(90*Math.random());
			}
		anim();
		
		tailUpdate();
		super.step();
		}
	private void die()
		{
		new Explosion(pos.clone());
		speed.add(-8,-6,0);
		anim = DEAD;
		headImg=2;
		eyeImg=2;
		}

	private void setXScale(int i)
		{
		boolean b = false;
		if(xScale!=i)
			b=true;
		xScale=i;
		if(b)
			tailRegen();
		}

	private void anim()
		{
		if(anim==DEAD)
			{
			eyeImg = 2;
			bodyImg = 1;
			headImg = 2;
			headRot = (headRot+Calc.toRad(60))/3;
			angle+=Calc.toRad(9);
			
			bwalk=0.18;
			fwalk=0.32;
			double up = -6;
			yPlus = (yPlus*2-up)/3;
			
			up = -6;
			BRx=7+0.07*walkAmplitude+1-12;
			BRy=(BRy*2+up)/3;
			BRi=2;
			BLx=7-0.07*walkAmplitude-12;
			BLy=(BLy*2+up)/3;
			BLi=2;
			
			
			up = -14;
			FRx=0.07*walkAmplitude-1;
			FRy=(FRy*2+up+8)/3;
			FRi=3;
			FLx=-0.07*walkAmplitude;
			FLy=(FLy*2+up+8)/3;
			FLi=3;
			}
		else if(anim==DUCK)
			{
			eyeImg = 2;
			bodyImg = 5;
			headImg = 2;
			headRot = (headRot+Calc.toRad(-90))/3;
			bwalk=0.18;
			fwalk=0.32;
			double up = -14;
			yPlus = (yPlus*2-up)/3;
			
			BRx=7+0.07*walkAmplitude+1;
			BRy=(BRy*2+up)/3;
			BRi=0;
			BLx=7-0.07*walkAmplitude;
			BLy=(BLy*2+up)/3;
			BLi=0;
			
			
			
			FRx=0.07*walkAmplitude-1;
			FRy=(FRy*2+up+8)/3;
			FRi=3;
			FLx=-0.07*walkAmplitude;
			FLy=(FLy*2+up+8)/3;
			FLi=3;
			}
		else if(anim==STAND)
			{
			yPlus=0;
			if(headDown)
				headRot=(headRot*2+Calc.toRad(-30))/3;
			else
				headRot=headRot/3;
			bwalk=0.18;
			fwalk=0.32;
			
			BRx=3+0.07*walkAmplitude+1;
			BRy=0;
			BRi=0;
			BLx=3-0.07*walkAmplitude;
			BLy=0;
			BLi=0;
			
			FRx=0.07*walkAmplitude+1;
			FRy=0;
			FRi=0;
			FLx=-0.07*walkAmplitude;
			FLy=0;
			FLi=0;
			
			bodyImg=0;
			}
		else if(anim==WALK)
			{
			yPlus=(beatTimer<15?1:0);
			if(headDown)
				headRot=(headRot*2+Calc.toRad(-20))/3;
			else
				headRot=headRot/3;
			int a=1;
			int h=3;
			bodyImg = (bwalk*4);
			bwalk+=1d/walkTime;
			if (bwalk>=1)
			    bwalk-=1;
			fwalk+=1d/walkTime;
			if (fwalk>=1)
			    fwalk-=1;
			
			int c;
			double rm;
			double rp;
			
			if(bwalk<0.5)
			    {
			    c=-1;
			    rm=-h;
			    rp=0;
			    BLi=1;
			    BRi=0;
			    }
			else
			    {
			    c=1;
			    rp=-h;
			    rm=0;
			    BLi=0;
			    BRi=1;
			    }
			BRx+=(c*walkAmplitude)/walkTime;
			BRy=(BRy*a+rp)/(a+1);
			BLx-=(c*walkAmplitude)/walkTime;
			BLy=(BLy*a+rm)/(a+1);
			if(fwalk<0.5)
			    {
			    c=-1;
			    rm=-h;
			    rp=0;
			    FLi=0;
			    FRi=1;
			    }
			else
			    {
			    c=1;
			    rp=-h;
			    rm=0;
			    FLi=1;
			    FRi=0;
			    }
			FRx-=c*walkAmplitude/walkTime;
			FRy=(FRy*a+rm)/(a+1);
			FLx+=c*walkAmplitude/walkTime;
			FLy=(FLy*a+rp)/(a+1);
			}
		else if (anim==JUMP)
			{
			yPlus=0;
			bwalk=0.18;
			fwalk=0.32;
			if(speed.p[1]<0)
			    {
			    BRx=(BRx*1+3+0.07*walkAmplitude+1)/2;
			    BRy=(BRy*1+2)/2;
			    BLx=(BLx*1+3)/2;
			    BLy=(BLy*1+3)/2;
			    FRx=(FRx*1+8)/2;
			    FRy=(FRy*1+-5)/2;
			    FLx=(FLx*1+-0.07*walkAmplitude)/2;
			    FLy=(FLy*1+-3)/2;
			    headRot=(headRot*1+Calc.toRad(10))/2;
			    }
			else
			    {
			    headRot=(headRot*2-Calc.toRad(30))/3;
			    BRx=(BRx*2+8)/3;
			    BRy=(BRy*2+-4)/3;
			    BLx=(BLx*2+3)/3;
			    BLy=(BLy*2+1)/3;
			    FRx=(FRx*2+8)/3;
			    FRy=(FRy*2+1)/3;
			    FLx=(FLx*2+-0.07*walkAmplitude)/3;
			    FLy=(FLy*2+0)/3;
			    }
			BRi=(speed.p[1]<0?1:0);
			BLi=(speed.p[1]<0?1:0);
			FRi=(speed.p[1]<0?1:0);
			FLi=(speed.p[1]<0?1:0);
			}
		else if(anim==RUN)
			{
			double t;
			yPlus=0;
			
			headImg = 2;
			
			headRot=(headRot*2+Calc.toRad(runPhase>0.5?(-35):(-22)))/3;
			runPhase += 1d/runTime;
			runPhase = runPhase%1;
			bodyImg=((runPhase>0.25 && runPhase<0.75)?4:5);
			
			BLi = (runPhase>0.25 && runPhase<0.75)?0:2;
			if(runPhase<0.5)
				BLx = walkAmplitude*1.5*(0.03+runPhase-0.25);
			else
				BLx = walkAmplitude*1.5*(0.03+0.75-runPhase);
			t = (runPhase>0.5 && runPhase<0.75)?0:-3;
			BLy = (BLy+t)/2;
			
			double arunPhase = runPhase-0.15;
			if(arunPhase<0)
				arunPhase+=1;
			double brunPhase = runPhase-0.3;
			if(brunPhase<0)
				brunPhase+=1;
			BRi = (arunPhase>0.25 && arunPhase<0.75)?0:2;
			if(arunPhase<0.5)
				BRx = walkAmplitude*1.5*(0.03+arunPhase-0.25);
			else
				BRx = walkAmplitude*1.5*(0.03+0.75-arunPhase);
			t = (arunPhase>0.5 && arunPhase<0.75)?0:-3;
			BRy = (BRy+t)/2;
			
			FRi = (arunPhase>0.25 && arunPhase<0.75)?0:2;
			if(arunPhase<0.5)
				FRx = walkAmplitude*1.5*(-0.01+arunPhase-0.25);
			else
				FRx = walkAmplitude*1.5*(-0.01+0.75-arunPhase);
			t = (arunPhase>0.5 && arunPhase<0.75)?0:-3;
			FRy = (FRy+t)/2;
			
			FLi = (brunPhase>0.25 && brunPhase<0.75)?0:2;
			if(brunPhase<0.5)
				FLx = walkAmplitude*1.5*(-0.01+brunPhase-0.25);
			else
				FLx = walkAmplitude*1.5*(-0.01+0.75-brunPhase);
			t = (brunPhase>0.5 && brunPhase<0.75)?0:-3;
			FLy = (FLy+t)/2;
			}
		}

	public void hit(int damage)
		{
		if(anim!=JUMP && anim!=DEAD)
			{
			if(damage>0 && anim!=DEFEND)
				{
				life -= damage;
				damageTimer=1;
				
				String hurt = "Hurt"+(int)(1+4*Math.random());
				Audio.get(hurt).play();
				eyeImg = 0;
				headImg = 2;
				if(Math.random()<0.5)
					{
					new SpeechBubble((String)Calc.choose(
							"Ouch!",
							"That hurt!",
							"We're under attack!",
							"Stop it!"), this);
					}
				}
			speed.set(-4,-4,0);
			pos.add(speed);
			anim = JUMP;
			targetX = flagHolder.targetX-128+Math.random()*200;
			if(life<=0)
				die();
			}
		}
	private void setTwitching(boolean twitch)
		{
		if(twitching!=twitch)
			{
			if(twitch)
				{
				if(Math.random()<0.5)
					{
					new SpeechBubble((String)Calc.choose(
							"Twitchy twitch!",
							"Something's gonna fall!",
							"Defend!",
							"Do something!"), this);
					}
				headImg = 2;
				}
			else
				headImg = 0;
			twitching = twitch;
			}
		}
	
	private void tailUpdate()
		{
		double h=Math.cos(angle);
		double v=-Math.sin(angle);
		double h2=-v;
		double v2=h;

		h*=xScale;
		v*=xScale;

		firstTail.pos.p[0]=pos.x()+(-12+3)*h+(-15+13+yPlus)*h2;
		firstTail.pos.p[1]=pos.y()+(-12+3)*v+(-15+13+yPlus)*v2;
		firstTail.x = new V3D(  -h*1.2-h2*1.2,
						 		-v*1.2-v2*1.2,
						 		0);
		firstTail.speed.set(speed);
		firstTail.speed.p[0]+=firstTail.x.x();
		firstTail.speed.p[1]+=firstTail.x.y();
		if(firstTail.next!=null)
			{
			firstTail.next.speed.add(firstTail.x,1.2);
			firstTail.next.next.speed.add(firstTail.x,0.8);
			firstTail.next.next.next.speed.add(firstTail.x,0.3);
			}
		}
	private void tailRegen()
		{
		Entity[] es = Scene.getInstances();
		for(Entity e:es)
			{
			if(e instanceof Tail)
				{
				if(((Tail) e).parent==this)
					e.destroy();
				}
			}
		int depth=-1;
		firstTail = new Tail(new V3D(0,0,0),hairColor,true,this,0,9);
		firstTail.setDepth(depth);
		tailUpdate();
		Tail p = firstTail;
		for(int n=1; n<=8; n++)
		    {
		    depth--;
		    Tail  i= new Tail(new V3D(p.pos.x()-1*xScale,p.pos.y()+2,0),hairColor,false,this,n,9);
		    firstTail.setDepth(depth);
		    p.next=i;
		    i.prev=p;
		    p=i;
		    }
		}
	@Override
	public void render()
		{
		GL2 gl = GFX.gl;
		gl.glPushMatrix();

		if(Portal.me!=null)
			{gl.glEnable(GL.GL_DEPTH_TEST);
			gl.glDepthMask(false);}
		
		gl.glPushMatrix();
		gl.glTranslated(pos.x(), pos.y(), pos.z());
		
		if (anim!=DEAD && damageTimer>0)
			{
			gl.glColor4f(0,0,0,(float)Math.min(1, damageTimer*3));
			GFX.drawRectangle(-32, -64, 32, -56);
			gl.glColor4f(1-(float)life/MAX_LIFE,(float)life/MAX_LIFE,0,(float)Math.min(1, damageTimer*3));
			GFX.drawRectangle(-32, -64, -32+(64*life)/MAX_LIFE, -56);
			}
		
		gl.glRotated(Calc.toDeg(angle), 0, 0, -1);
		gl.glScaled(xScale,1,1);
		gl.glTranslated(-12,-15+yPlus,0);
		
		gl.glColor3f(color[0]/2,color[1]/2,color[2]/2);
		renderLegs(-1,0,false);
		renderLegs(1,0,false);
		
		renderLegs(-1,0,true);
		renderLegs(1,0,true);
		if(flagHolder==this && !thrownFlag)
			{
			gl.glColor4fv(GFX.WHITE,0);
			GFX.drawTexture(GFX.tex("Flag"), flagType, 12+4*xScale, 15, 0, GFX.SOUTHWEST, 
					(float)(-Math.sin(Math.PI*2*beatTimer/30)), 1, 
					(float)(((flagType!=IDLE&&flagType!=FLINCH)?1:0.5)*Math.cos(Math.PI*2*beatTimer/30)));
			}

		gl.glColor4fv(color,0);
		
		
		GFX.drawTexture(GFX.tex("PonyBody"), (int)bodyImg, 0, 0, 0, GFX.NORTHWEST, 1, 1, 0);
		renderLegs(0,0,false);
		GFX.drawTexture(GFX.tex("PonyHead"), (int)headImg, (bodyImg<4?13:24)+9, (bodyImg<4?-17:-9)+17, 0, GFX.NORTHWEST, 1f, 1f, (float)(headRot));
		
		gl.glColor4fv(GFX.WHITE,0);
		GFX.drawTexture(GFX.tex("PinkieCutieMark"), 0, 0, 0, 0, GFX.NORTHWEST, 1, 1, 0);
		GFX.drawTexture(GFX.tex("PonyEye"), (int)eyeImg, (bodyImg<4?13:24)+9, (bodyImg<4?-17:-9)+17, 0, GFX.NORTHWEST, 1f, 1f, (float)(headRot));
		//gl.glColor4fv(eyeColor,0);
		//GFX.drawTexture(GFX.tex("PonyIris"), (int)eyeImg, (bodyImg<4?13:24)+9, (bodyImg<4?-17:-9)+17, 0, GFX.NORTHWEST, 1f, 1f, (float)(headRot));
		
		gl.glColor4fv(hairColor,0);
		GFX.drawTexture(GFX.tex("PonyHair"), (int)0, (bodyImg<4?13:24)+9, (bodyImg<4?-17:-9)+17, 0, GFX.NORTHWEST, 1f, 1f, (float)(headRot));
		

		gl.glPopMatrix();
		
		Tex ponyTail = GFX.tex("PonyTail");
		ponyTail.enable(0);
		
		
		gl.glBegin(GL2.GL_TRIANGLE_STRIP);
		Tail curr = firstTail;
		double tailRadius = 7;
		for(int i=0; i<=8; i++)
			{
			float cx = 1-(float)i/8;
			double h = tailRadius*Math.cos(curr.dir+Math.PI/2);
			double v = -tailRadius*Math.sin(curr.dir+Math.PI/2);
			gl.glTexCoord2f(ponyTail.xMult*cx, ponyTail.yMult*(0.5f+(float)xScale/2));
			gl.glVertex2d(curr.pos.x()+h, curr.pos.y()+v);
			gl.glTexCoord2f(ponyTail.xMult*cx, ponyTail.yMult*(0.5f-(float)xScale/2));
			gl.glVertex2d(curr.pos.x()-h, curr.pos.y()-v);
			curr = curr.next;
			}
		gl.glEnd();
		gl.glDisable(GL2.GL_TEXTURE_2D);
		
		if(Portal.me!=null)
			{gl.glDisable(GL.GL_DEPTH_TEST);
			gl.glDepthMask(true);}
		
		gl.glPopMatrix();
		}
	/**
	 * 
	 * @param x offset
	 * @param y offset
	 */
	private void renderLegs(int x, int y, boolean right)
		{
		final double bx=-8;
		final double fx=9;
		final double dy=13;
		
		final double ox=12;
		final double oy=15;
		
		GL2 gl = GFX.gl;
		if(!right)
			{
			//L
			gl.glPushMatrix();
			gl.glTranslated(x,y,0);
			gl.glPushMatrix();
			
			gl.glTranslated(ox+bx,oy,0);
			GFX.drawTexture(sB1,0,0,0,0,GFX.NORTHWEST,1,1,(float) Calc.dir(0,0,BLx,BLy+dy));
			gl.glTranslated(BLx,BLy+dy,0);
			GFX.drawTexture(sB3,(int) BLi,0,0,0,GFX.NORTHWEST,1,1,0);
	
			gl.glPopMatrix();
			
			gl.glTranslated(ox+fx,oy,0);
			GFX.drawTexture(sF1,0,0,0,0,GFX.NORTHWEST,1,1,(float) Calc.dir(0,0,FLx,FLy+dy));
			gl.glTranslated(FLx,FLy+dy,0);
			GFX.drawTexture(sF3,(int) FLi,0,0,0,GFX.NORTHWEST,1,1,0);
	
			gl.glPopMatrix();
			}
		else
			{
			//R
			gl.glPushMatrix();
			gl.glTranslated(x,y,0);
			gl.glPushMatrix();
	
			gl.glTranslated(ox+bx,oy,0);
			GFX.drawTexture(sB1,0,0,0,0,GFX.NORTHWEST,1,1,(float) Calc.dir(0,0,BRx,BRy+dy));
			gl.glTranslated(BRx,BRy+dy,0);
			GFX.drawTexture(sB3,(int) BRi,0,0,0,GFX.NORTHWEST,1,1,0);
	
			gl.glPopMatrix();
			
			gl.glTranslated(ox+fx,oy,0);
			GFX.drawTexture(sF1,0,0,0,0,GFX.NORTHWEST,1,1,(float) Calc.dir(0,0,FRx,FRy+dy));
			gl.glTranslated(FRx,FRy+dy,0);
			GFX.drawTexture(sF3,(int) FRi,0,0,0,GFX.NORTHWEST,1,1,0);
			
			gl.glPopMatrix();
			}
		}

	@Override 
	public void alarm(int n)
		{
		if(n==0)//March after flag holder
			{
			if(Math.random()<0.15)
				{
				new SpeechBubble((String)Calc.choose(
						"Let's go!",
						"Pata Pata Pata Pon!",
						"Onward March!",
						"Where are we going?!"), this);
				}
			eyeImg = 0;
			headImg = 0;
			mode = MARCH;
			targetX = flagHolder.targetX-128+Math.random()*200;
			}
		else if(n==1)//Charge
			{
			if(Math.random()<0.15)
				{
				new SpeechBubble((String)Calc.choose(
						"Attack!!",
						"Pon Pon Pata Pon!",
						"Nopony breaks a Pinkie Promise!",
						"Grr!"), this);
				}
			eyeImg = 2;
			headImg = 2;
			mode = ATTACK;
			targetX = flagHolder.targetX+(PataController.me.numValidMeasures>=10?320:160)+Math.random()*64;
			}
		else if(n==2)//Duck
			{
			if(Math.random()<0.15)
				{
				new SpeechBubble((String)Calc.choose(
						"Hide!",
						"Clop Clop Pata Pon!",
						"Scared!",
						"Ducking!"), this);
				}
			mode = DEFEND;
			targetX = pos.x();
			}
		else if(n==3)//Unknown
			{
			}
		else if(n==4)//Fail
			{
			if(Math.random()<0.15)
				{
				new SpeechBubble((String)Calc.choose(
						"Fail",
						"What in the hay?",
						"???",
						"????",
						"Make it stop!",
						"What?"), this);
				}
			if(Math.random()<0.5)
				eyeImg = 2;
			if(Math.random()<0.5)
				headDown = true;
			headImg = 2;
			alarm[6]=30;
			
			}
		else if(n==5)//Stop flagging(flag holder only)
			{
			eyeImg = 0;
			headImg = 0;	
			setFlagType(IDLE);
			}
		else if(n==6)//Reset headEyeImg
			{
			eyeImg = 0;
			headImg = 0;
			headDown = false;
			}
		else if(n==7)//Twitchy twitch
			{
			setTwitching(true);
			}
		else if(n==8)//Jump for joy
			{
			if(Math.random()<0.5)
				{
				new SpeechBubble((String)Calc.choose(
						"Did we win?",
						"Woohoo!!",
						"I knew you could do it!",
						"I still don't see what's going on..."), this);
				}
			int i = (int)(Math.random()*4);
			StupidClip c;
			if(i<2)
				c = Audio.get("Woohoo"+String.valueOf(1+(int)(3*Math.random())));
			else if (i==2)
				c = Audio.get("Whee"+String.valueOf(1+(int)(2*Math.random())));
			else
				c = Audio.get("Woo"+String.valueOf(1+(int)(2*Math.random())));
			c.play();
			c.setGain(1);
			speed.add(walkSpeed,-4,0);
			pos.add(speed);
			anim = JUMP;
			}
		else if(n==9)//Party
			{
			/*if(Math.random()<0.5)
				{
				new SpeechBubble((String)Calc.choose(
						"Did we win?",
						"Woohoo!!",
						"I knew you could do it!",
						"I still don't see what's going on..."), this);
				}*/
			int i = (int)(Math.random()*4);
			StupidClip c;
			if(i<2)
				c = Audio.get("Woohoo"+String.valueOf(1+(int)(3*Math.random())));
			else if (i==2)
				c = Audio.get("Whee"+String.valueOf(1+(int)(2*Math.random())));
			else
				c = Audio.get("Woo"+String.valueOf(1+(int)(2*Math.random())));
			c.play();
			c.setGain(0.75);
			speed.add(walkSpeed,-4,0);
			pos.add(speed);
			anim = JUMP;
			}
		else if(n==10)//Run to end
			{
			targetX = Integer.MAX_VALUE; 
			mode = ATTACK;
			}
		}
	private void beat(int beatIndex, int numValidMeasures)
		{
		if(beatIndex%2==0)
			beatTimer=0;
		
		/*if(numValidMeasures>0)
			{
			eyeImg=1;
			alarm[0]=4;
			}*/
		}

	private void unknown()
		{
		if(flagHolder == this)
			{
			targetX = pos.x();
			setFlagType(FLINCH);
			mode = IDLE;
			}
		else
			alarm[4] = 1+(int) (Math.random()*60);//Delay
		}

	private void march()
		{
		if(flagHolder == this)
			{
			targetX+=walkSpeed*((PataController.me.beatTime*Main.FPS*7)/1000);
			setFlagType(MARCH);
			mode = MARCH;
			}
		else
			alarm[0] = 1+(int) (Math.random()*30);//Delay
		}

	private void attack()
		{
		
		if(flagHolder == this)
			{
			targetX=pos.x();
			setFlagType(ATTACK);
			mode = IDLE; 
			}
		else
			alarm[1] = 1+(int) (Math.random()*30);//Delay
		}

	private void setFlagType(int type)
		{
		if(type==IDLE)
			headImg=0;
		else
			headImg=1;
		flagType = type;
		alarm[5] = 60;
		}

	private void defend()
		{
		
		if(flagHolder == this)
			{
			targetX=pos.x();
			setFlagType(DEFEND);
			mode = IDLE;
			}
		else
			alarm[2] = 1+(int) (Math.random()*30);//Delay
		}

	private void fail()
		{
		if(flagHolder==this)
			{
			targetX=pos.x();
			}
		else
			{
			
			if(mode==MARCH)
				targetX = Math.max(pos.x(),flagHolder.pos.x()-128+Math.random()*200);
			else if(mode==ATTACK)
				targetX = flagHolder.pos.x()-128+Math.random()*200;
			mode = MARCH;
			}
		alarm[4] = 1+(int)(Math.random()*15);
		}
	

	public static void allWin()
		{
		for(Pinkie p:pinkies)
			{
			p.win();
			}
		}
	private void win()
		{
		if(flagHolder==this)
			{
			setFlagType(FLINCH);
			}
		targetX=PataController.goalX+1024;
		mode = MARCH;
		eyeImg = 0;
		headImg = 1;
		alarm[8] = 2+(int)(Math.random()*90);
		}
	
	public static void allParty()
		{
		View.targetScale = 2;
		for(Pinkie p:pinkies)
			{
			p.party();
			}
		}
	
	private void party()
		{
		if(flagHolder==this)
			{
			setFlagType(FLINCH);
			}
		targetX=PataController.goalX;
		mode = MARCH;
		eyeImg = 0;
		headImg = 1;
		alarm[9] = 2+(int)(Math.random()*64);
		}

	public static void allTwitch(boolean b)
		{
		if(b)
			Audio.get("Twitch").play();
		for(Pinkie p:pinkies)
			{
			if(b)
				p.alarm[7] = (int)(Math.random()*60);
			else
				p.setTwitching(false);
			}
		}
	
	/**@param beatIndex 0-7, 0-3 for user input measure and 4-7 for second measure. 
	 * Does not reach second measure if the user doesn't do anything.*/
	public static void allBeat(int beatIndex, int numValidMeasures)
		{
		for(Pinkie p:pinkies)
			p.beat(beatIndex,numValidMeasures);
		}
	public static void allInputPattern(int[] userInput)
		{
		View.targetScale = 1.5+(isEnemyClose()?0.5:0);
		//Respond to user input 
		if(	userInput[0]==0 &&
			userInput[1]==0 &&
			userInput[2]==1 &&
			userInput[3]==0)
			{
			for(Pinkie p:Pinkie.pinkies)
				p.attack();
			}
		else if(userInput[0]==1 &&
				userInput[1]==1 &&
				userInput[2]==1 &&
				userInput[3]==0)
			{
			View.targetScale = 2;
			for(Pinkie p:Pinkie.pinkies)
				p.march();
			}
		else if(userInput[0]==2 &&
				userInput[1]==2 &&
				userInput[2]==1 &&
				userInput[3]==0)
			{
			for(Pinkie p:Pinkie.pinkies)
				p.defend();
			}
		else //Unknown command
			{
			for(Pinkie p:Pinkie.pinkies)
				p.unknown();
			}
		}
	public static void allFail()
		{
		View.targetScale = 1+(isEnemyClose()?0.5:0);
		for(Pinkie p:Pinkie.pinkies)
			p.fail();
		}

	private static boolean isEnemyClose()
		{
		ArrayList<Enemy> list = PataController.getEnemyList();
		for(int i=0; i<list.size(); i++)
			{
			if(list.get(i).getPosition().x()>View.x && list.get(i).getPosition().x()<View.x+640)
				return true;
			}
		return false;
		}

	@Override
	public double getXScale()
		{
		return xScale;
		}
	@Override
	public boolean isTwitching()
		{
		return twitching;
		}

	}
