package game;

import com.jogamp.opengl.GL;
import com.jogamp.opengl.GL2;

import audio.Audio;

import graphics.GFX;
import calc.V3D;
import mechanics.Entity;
import mechanics.Scene;

public class Portal extends Entity
	{
	float vol;
	public static Portal me;
	public Portal(V3D pos)
		{
		super(pos);
		me = this;
		vol = 0;
		setDepth(100);
		tex = GFX.tex("portal");
		Audio.get("ffAmb").setLooping(true);
		Audio.get("ffAmb").play();
		Audio.get("ffAmb").setGain(vol);
		}
	
	@Override
	public void destroy()
		{
		super.destroy();
		Audio.get("ffOff").play();
		Audio.get("ffAmb").stop();
		me = null;
		}
	@Override
	public void step()
		{
		super.step();
		if(vol<0.8)
			vol+=1f/90;
		Audio.get("ffAmb").setGain(vol);
		}
	@Override
	public void render()
		{
		GL2 gl = GFX.gl;
		
		if(Scene.blink==0)
			GFX.drawTexture(tex, (int) image, (float)pos.x(), (float)pos.y(), 0, GFX.SOUTH, 1, 1, 0);
		
		gl.glCullFace(GL.GL_BACK);
		gl.glEnable(GL.GL_DEPTH_TEST);
        gl.glDepthFunc(GL.GL_LEQUAL);
        gl.glHint(GL2.GL_PERSPECTIVE_CORRECTION_HINT, GL.GL_NICEST);
        gl.glClearDepth(1.0f);
        gl.glClear(GL2.GL_DEPTH_BUFFER_BIT);
        
        
        gl.glColor4f(1,1,1,0f);
        gl.glBegin(GL2.GL_TRIANGLE_STRIP);
        int n = 12; 
        for(int i=0; i<=n; i++)
        	{
        	double a = i*Math.PI/n;
        	gl.glVertex3d(pos.x()+480, pos.y()-40+40*Math.cos(a), pos.z());
        	gl.glVertex3d(pos.x()+16*Math.sin(a), pos.y()-40+40*Math.cos(a), pos.z());
        	}
        gl.glEnd();

        
        gl.glColor4f(1,1,1,1);
        gl.glDisable(GL.GL_DEPTH_TEST);
		}
	
	}
