package game;

import audio.Audio;
import graphics.BlendMode;
import graphics.GFX;
import calc.Calc;
import calc.V3D;
import mechanics.Entity;
import mechanics.Scene;

public class Roar extends Entity
	{
	
	boolean dangerous = true;
	
	public Roar(V3D pos)
		{
		super(pos);
		tex = GFX.tex("Roar");
		angle = (float) Calc.toRad(30);
		double s = 12;
		speed.set(-Math.cos(angle)*s,Math.sin(angle)*s,0);
		orientation = GFX.CENTER;
		yScale = 0;
		setDepth(-50);
		bm = BlendMode.ADD;
		}

	@Override
	public void step()
		{
		super.step();
		yScale = (yScale*15+1)/16;
		if(pos.y()>PataController.GND_Y-56*yScale)
			{
			if(Scene.fourstage==0)
				{
				Audio.get("splashStep").play();
				Audio.get("splashStep").setGain(0.75);
				}
			if(pos.y()>PataController.GND_Y+64*yScale)
				{
				destroy();
				}
			else if(dangerous)
				{
				double pX = pos.x()+0.35*(PataController.GND_Y-pos.y());
				for(Pinkie p : Pinkie.pinkies)
					{
					if(p!=Pinkie.flagHolder && p.anim!=Pinkie.DUCK && Math.abs(pX-p.pos.x())<24)
						{
						p.hit(1);
						}
					}
				}
			}
			
		
		
		}
	}
