package game;

import java.util.ArrayList;

import audio.Audio;

import graphics.GFX;
import calc.V3D;
import mechanics.Entity;

public class Rock extends Entity implements Enemy
	{
	int radius;
	boolean falling;
	public Rock(V3D pos)
		{
		super(pos);
		PataController.addEnemy(this);
		tex = GFX.tex("rock32");
		radius = 12;
		falling = false;
		}
	
	@Override
	public void step()
		{
		if(falling)
			{
			speed.add(0,0.25,0);
			if(pos.y()>PataController.GND_Y+32)
				destroy();
			}
		super.step();
		if(!falling)
			{
			ArrayList<Pinkie> ps = Pinkie.pinkies;
			int i=0;
			while (i<ps.size())
				{
				Pinkie p = ps.get(i);
				if(pos.distance(p.pos)<Pinkie.RADIUS+radius && p.anim!=Pinkie.DEAD)
					{
					if(p.anim==Pinkie.RUN)
						{
						fall(p.speed);
						}
					else
						Audio.get("rock1").play();
					p.hit(0);
					}
				
				i++;
				}
			}
		}

	private void fall(V3D impulse)
		{
		Audio.get("rock2").play();
		speed.set((Math.random()-0.5)*4,(Math.random()-0.5)*4,0);
		speed.add(impulse,0.5);
		falling=true;
		}

	static void rockPile(int x)
		{
		for(int j=0; j<4; j++)
			{
		for(int i=x-24/(1+j); i<=x+24/(1+j); i+=12)
				{
				Rock r = new Rock(new V3D(i-4+(int)(Math.random()*8)-j*5,PataController.GND_Y-j*12-2+(Math.random()*4),0));
				r.setDepth((int)Math.signum(Math.random()-0.5));
				double m =1d/(1+j/2)+Math.random()/10;
				r.xScale*=m;
				r.yScale*=m;
				r.radius*=m;
				}
			}
		}

	@Override
	public V3D getPosition()
		{
		return pos;
		}
	}
