package game;

import graphics.GFX;
import graphics.Tex;
import calc.V3D;
import mechanics.Entity;

public class Scenery extends Entity
	{
	boolean scaleX;
	int stayInView;
	/**If negative, flip x*/
	public double scaleMultiplier = 1;
		
	public Scenery(V3D pos, Tex tex)
		{
		super(pos);
		this.tex = tex;
		setDepth(100);
		orientation = GFX.SOUTH;
		scaleX=true;
		stayInView = -1;
		}
	@Override
	public void step()
		{
		if(PataController.me.numValidMeasures>=10)
			{
			if(scaleX)
				xScale = (1-(float)Math.sin(Math.PI*2*PataController.beatTimer/30)/16)*((float)scaleMultiplier);
			yScale = (1+(float)Math.sin(Math.PI*2*PataController.beatTimer/30)/16)*(float)Math.abs(scaleMultiplier);
			}
		else
			{
			xScale=((float)scaleMultiplier);
			yScale=(float)Math.abs(scaleMultiplier);
			}
		if(stayInView!=-1 && pos.x()<View.x-tex.getWidth())
			pos.p[0]+=stayInView;
		if(stayInView!=-1 && pos.x()>View.x+View.width)
			pos.p[0]-=stayInView;
		}
	
	public static Scenery spawn(int x, String texName)
		{
		return new Scenery(new V3D(x,PataController.GND_Y,0),GFX.tex(texName));
		}
	public static Scenery spawnDecal(int x, String texName)
		{
		Scenery s = new Scenery(new V3D(x,PataController.GND_Y,0),GFX.tex(texName));
		s.scaleMultiplier = 0.33+0.67*Math.random()*Math.random();
		s.orientation = GFX.SOUTHWEST;
		if(Math.random()<0.5)
			{s.scaleMultiplier*=-1;
			s.orientation = GFX.SOUTHEAST;}
		s.scaleX = false;
		s.stayInView = 2048;
		s.setDepth(-1000);
		return s;
		}
	public static void spawnGrass()
		{
		for(int i=0; i<2048; i+=160)
			{
			if(Math.random()<0.5)
				spawnDecal(i+(int)(Math.random()*128),"grass"+String.valueOf(1+(int)(Math.random()*3)));
			else if(Math.random()<0.5)
				spawnDecal(i+(int)(Math.random()*128),"stone"+String.valueOf(1+(int)(Math.random()*3)));
			}
		}
	}
