package game;

import java.awt.Point;
import java.awt.geom.Rectangle2D;
import java.util.ArrayList;

import mechanics.Entity;

public class SpeechBubble extends Entity
	{
	static ArrayList<SpeechBubble> bubbles = new ArrayList<SpeechBubble>();

	static final int INIT_YOFF = -80;
	static final int YOFF_MULT = -18;
	static final int NUM_YOFF = 12;
	static int numBubbles = 0;
	static boolean[] yOffTaken = new boolean[NUM_YOFF];
	
	int yOff; 
	
	String talkString,targetString;
	int stringPos, talkTimer;
	Pinkie talker;
	/**Used by overlay to avoid duplicate work.*/
	public Rectangle2D bounds;
	
	public SpeechBubble(String targetString, Pinkie talker)
		{
		super(talker.pos.clone());
		
		yOff = 0;
		while(yOff<NUM_YOFF-1 && yOffTaken[yOff])
			{
			yOff++;
			}
		numBubbles++;
		yOffTaken[yOff] = true;
		
		bubbles.add(this);
		this.targetString = targetString;
		stringPos = 0;
		talkTimer = 0;
		talkString = "";
		this.talker = talker;
		}
	@Override
	public void destroy()
		{
		super.destroy();
		bubbles.remove(this);
		SpeechBubble.yOffTaken[yOff] = false;
		numBubbles--;
		}
	
	@Override
	public void alarm(int i)
		{
		if(i==0)
			destroy();
		}
	@Override
	public void step()
		{
		super.step();
		if(talker!=null)
			{
			pos.set(talker.pos).add((View.x+View.width/2-pos.x())/4,yOff*YOFF_MULT+INIT_YOFF,0);
			if(talker.headImg<2)
				talker.headImg=0;
			}
		if(stringPos<targetString.length())
			{
			talkTimer+=3;
			if(talkTimer>=15)
				talkTimer=0;
			if(talkTimer<7 && talker!=null && talker.headImg<2)
				talker.headImg=1;
	
			if(talkTimer%3==0)
				{
				talkString+=targetString.charAt(stringPos);
				stringPos++;
				if(stringPos>=targetString.length())
					{
					if(talker!=null && talker.headImg<2)
						talker.headImg=0;
					alarm[0]=10+(int)(Math.random()*30);
					}					
				}
			}
		}

	public Point getPositionOnScreen(int screenW,int screenH)
		{
		return new Point((int)((double)screenW*(pos.x()-View.x)/View.width),
						 (int)((double)screenH*(pos.y()-View.y)/View.height));
		}

	}
