package game;

import com.jogamp.opengl.GL2;

import graphics.GFX;
import calc.Calc;
import calc.V3D;
import mechanics.Entity;

public class Tail extends Entity
	{
	Tail next = null, prev = null;
	TailParent parent;
	/**Speed adder(only defined for root)*/
	V3D x;
	boolean root;
	int index;
	int total;
	V3D c0 = new V3D(), c1 = new V3D(), c2 = new V3D();
	int maxDist = 5;
	/**Local coordinate system*/
	double dir;

	public Tail(V3D pos, float[] color, boolean root, TailParent parent, int index, int total)
		{
		super(pos);
		this.color = color;
		this.root = root;
		this.parent = parent;
		this.total = total;
		this.index = index;
		visible = false;
		speed.set(V3D.ZERO);
		}
	@Override
	public void step()
		{	
		super.step();
		if(parent.isTwitching() && !root)
			speed.add(-Math.pow(Math.random(),2)*this.parent.getXScale()*16,-Math.pow(Math.random(),2)*20,0);
		if(root)
			dir = Calc.dir(0,0,x.x(),x.y());
		else
			{
		    softScript();
			dir = Calc.dir(prev.pos.x(), prev.pos.y(), pos.x(),pos.y());
			}
		speed.p[1]+=0.15;
		}
	@Override
	public void endStep()
		{
		}
	private void softScript()
		{
		if(prev!=null) // Not root
			{
			speed.accelerate(-speed.sqLen()/512);
			if(prev.root)//Previous is root
				{
				c0.set(pos).add(prev.pos, -1);
				V3D diff = c0;
				//double dist = diff.len();
				diff.normalize();
				c1.set(speed).add(prev.speed,-1);
				V3D diffSpeed = c1;
				double d = diffSpeed.dot(diff);
				//if(dist>=maxDist)
					{
					pos.set(prev.pos).add(diff,maxDist);
					speed.add(diff,-d);
					}
				}
			else
				{
				//speed.makeAverage(new V3D(Math.cos(dir),-Math.sin(dir),0),0.05);
				c0.set(pos).add(prev.pos, -1);
				V3D diff = c0;
				double dist = diff.len();
				diff.normalize();
				c1.set(speed).add(prev.speed,-1);
				V3D diffSpeed = c1;
				double d = diffSpeed.dot(diff);
				if(dist>maxDist)
					{
					pos.makeAverage(c2.set(prev.pos).add(diff,maxDist),1);
					prev.pos.makeAverage(c2.set(pos).add(diff,-maxDist),1);
					prev.speed.add(diff,d*0.95);
					speed.add(diff,-d*0.95);
					speed.accelerate(-0.01*speed.sqLen());
					}
				}
			}
		}
	@Override
	public void render()
		{
		GL2 gl = GFX.gl;
		gl.glPushMatrix();
		gl.glTranslated(pos.x(), pos.y(), pos.z());
		gl.glRotated(dir*180d/Math.PI, 0, 0, -1);
		gl.glScaled(4, 1, 2);
		GFX.unitCube.render();
		gl.glPopMatrix();
		}
	}
