package game;

import com.jogamp.opengl.GL2;

import graphics.BlendMode;
import graphics.GFX;
import calc.V3D;
import mechanics.Entity;

public class View extends Entity
	{
	static double x,y,width,height;
	static double targetScale;
	int skyTimer=0;
	
	public View(V3D pos)
		{
		super(pos);
		setDepth(Integer.MAX_VALUE);
		
		
		x=pos.x();
		y=pos.y();
		width=320;
		height=240;
		targetScale=1;
		GFX.gl.glEnable(GL2.GL_BLEND);
		BlendMode.NORMAL.set();
		}
	@Override
	public void step()
		{
		skyTimer+=1;
		if(skyTimer>=480*640)
			skyTimer=0;
		x = Pinkie.flagHolder.pos.x()-160-(width-320)/8;
		x = Math.min(x,PataController.goalX-width+160);
		//System.out.println(x+", "+(PataController.goalX-width+160));
		
		y = -(height-240)*3/4-((Intro.introductionRunning)?Intro.yMinus:0);
		
		if(width<320*targetScale)
			width+=2;
		if(width>320*targetScale)
			width-=2;
		if(height<240*targetScale)
			height+=2;
		if(height>240*targetScale)
			height-=2;
		
		width=(width*15+320*targetScale)/16;
		height=(height*15+240*targetScale)/16;
		}
	@Override
	public void render()
		{
		GL2 gl = GFX.gl;
		
		gl.glClearColor(0,0,0,1);
		gl.glClear(GL2.GL_COLOR_BUFFER_BIT);
		
		gl.glLoadIdentity();
		gl.glOrtho(x, x+width, y+height, y, -6400, 6400);
		
		gl.glBegin(GL2.GL_TRIANGLE_STRIP);
		gl.glColor3f(0.75f,0.88f,1f);
		gl.glVertex2d(x,-960);
		gl.glVertex2d(x+width,-960);
		gl.glVertex2d(x,-240);
		gl.glVertex2d(x+width,-240);
		gl.glColor3f(0.4f,0.6f,0.9f);
		gl.glVertex2d(x,PataController.GND_Y);
		gl.glVertex2d(x+width,PataController.GND_Y);
		gl.glEnd();
		
		gl.glColor4f(1, 1, 1, 0.5f);
		int x1;
		x1=(int)(View.x*0.75)-skyTimer/2;
		while(x1<View.x-320)
			x1+=320;
		GFX.drawTexture(GFX.tex("Skies1"), 0, x1, PataController.GND_Y-280, 0, GFX.NORTHWEST, 1, 1, 0);
		GFX.drawTexture(GFX.tex("Skies1"), 0, x1+320, PataController.GND_Y-280, 0, GFX.NORTHWEST, 1, 1, 0);
		GFX.drawTexture(GFX.tex("Skies1"), 0, x1+640, PataController.GND_Y-280, 0, GFX.NORTHWEST, 1, 1, 0);
		GFX.drawTexture(GFX.tex("Skies1"), 0, x1+960, PataController.GND_Y-280, 0, GFX.NORTHWEST, 1, 1, 0);
		
		gl.glColor4f(1, 1, 1, 0.75f);
		x1=(int)(View.x*0.9)-skyTimer;
		while(x1<View.x-480)
			x1+=480;
		GFX.drawTexture(GFX.tex("Skies2"), 0, x1, PataController.GND_Y-360, 0, GFX.NORTHWEST, 1, 1, 0);
		GFX.drawTexture(GFX.tex("Skies2"), 0, x1+480, PataController.GND_Y-360, 0, GFX.NORTHWEST, 1, 1, 0);
		GFX.drawTexture(GFX.tex("Skies2"), 0, x1+960, PataController.GND_Y-360, 0, GFX.NORTHWEST, 1, 1, 0);
		
		gl.glColor4f(1, 1, 1, 1f);
		x1=(int)(View.x*0.5);
		while(x1<View.x-1024)
			x1+=1024;
		GFX.drawTexture(GFX.tex("mountain"), 0, x1, PataController.GND_Y-192, 0, GFX.NORTHWEST, 1, 1, 0);
		GFX.drawTexture(GFX.tex("mountain"), 0, x1+1024, PataController.GND_Y-192, 0, GFX.NORTHWEST, 1, 1, 0);
		}
	}